package com.huifu.example.acou;

import com.alibaba.fastjson.JSON;
import com.huifu.hfpay.master.domain.CfcaInfoBo;
import com.huifu.hfpay.master.util.constant.Constants;
import com.huifu.hfpay.master.util.security.SecurityService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author zhiwei.cai
 * @Description 修改支付密码
 * @Date 13:33 2019/8/14
 * @param
 * @return 
 **/
@Controller
@RequestMapping(value = "/")
public class Pwdmod {

	public static Logger log = LoggerFactory.getLogger(Pwdmod.class);

	//商户客户号
	private static final String merCustId="6666000000002619";
	//用户客户号
	private static final String userCustId="6666000000066188";
	//修改支付密码请求地址
	private static final String payUrl="https://hfpay.testpnr.com/api/acou/pwdmod";
	//加签证书地址
	private static final String pfxFile="/app/etc/product/888888-NEW.pfx";
	//加签证书秘钥
	private static final String pfxFilePwd="123456";
	//解签证书地址
	private static final String cerFile="/app/etc/product/CFCA_ACS_TEST_OCA31.cer";
	//解签证书所属商户号
	private static final String hfMerId="100001";
	/**
	 * 修改支付密码，并跳转到页面
	 * @param map
	 * @param request
	 * @param response
	 * @param session
	 * @return
	 * @throws Exception
	 */
	@RequestMapping(value = "/pwdmod")
	public String pay(ModelMap map, HttpServletRequest request,
			HttpServletResponse response, HttpSession session) throws Exception {
		//组装支付+请求参数
		Map<String, String> payParams = new HashMap<String, String>();
		payParams.put(Constants.VERSION, Constants.VERSION_VALUE);
		payParams.put(Constants.MER_CUST_ID, merCustId);
		payParams.put(Constants.USER_CUST_ID, userCustId);
		payParams.put(Constants.ORDER_ID, makeOrderId());
		SimpleDateFormat dateformat = new SimpleDateFormat("yyyyMMdd");
		String dateStr = dateformat.format(System.currentTimeMillis());
		payParams.put(Constants.ORDER_DATE, dateStr);

		payParams.put(Constants.RET_URL, "http://abc.com");

		payParams.put(Constants.MER_PRIV, "");
		payParams.put(Constants.EXTENSION, "");

		CfcaInfoBo cfcaInfoBo = new CfcaInfoBo();
		// 解签证书
		cfcaInfoBo.setCerFile(cerFile);
		// 加签证书
		cfcaInfoBo.setPfxFile(pfxFile);
		// 加签密码
		cfcaInfoBo.setPfxFilePwd(pfxFilePwd);
		// 商户ID
		cfcaInfoBo.setNpayMerId(hfMerId);
		
		// 转换成json格式
		String paramsStr = JSON.toJSONString(payParams);
		log.info("取现请求参数："+paramsStr);
		// 加签
		String sign = SecurityService.sign(paramsStr,cfcaInfoBo);
		
		map.put("version", Constants.VERSION_VALUE);
		map.put("merCustId", merCustId);
		//设置加签后的接口参数
		map.put("sign", sign);
		//设置接口地址
		map.put("url", payUrl);

		return "submit";
	}
	
	/**
	 * 生成订单号
	 * @return
	 */
	private String makeOrderId(){
		return "TEST"+System.currentTimeMillis();
	}

	
}
