package com.huifu.example.file;

import com.alibaba.fastjson.JSON;
import com.huifu.hfpay.master.domain.CfcaInfoBo;
import com.huifu.hfpay.master.util.constant.Constants;
import com.huifu.hfpay.master.util.security.SecurityService;
import jodd.http.HttpRequest;
import jodd.http.HttpResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.File;
import java.util.HashMap;
import java.util.Map;

/**
 * 上传文件
 * @author yinfeng.yuan
 */
@Controller
@RequestMapping(value = "/")
public class File01 {
	public static Logger log = LoggerFactory.getLogger(File01.class);

	//商户客户号
	private static final String merCustId="6666000000114846";
	//文件上传请求地址
	private static final String fileUrl="https://hfpay.testpnr.com/api/alse/file01";
	//加签证书地址
	private static final String pfxFile="/app/etc/product/888888-NEW.pfx";
	//加签证书秘钥
	private static final String pfxFilePwd="123456";
	//解签证书地址
	private static final String cerFile="/app/etc/product/CFCA_ACS_TEST_OCA31.cer";
	//解签证书所属商户号
	private static final String hfMerId="100001";
	@RequestMapping(value = "/file01")
	@ResponseBody
	public String pay(ModelMap map, HttpServletRequest request,
			HttpServletResponse response, HttpSession session) throws Exception {
		log.info("************文件上传请求**************");

		//组装请求参数
		Map<String, String> payParams = new HashMap<String, String>();
		payParams.put(Constants.VERSION, Constants.VERSION_VALUE);	
		payParams.put(Constants.MER_CUST_ID, merCustId);
		payParams.put(Constants.ATTACH_NO, "a2454422338");
		payParams.put(Constants.TRANS_TYPE, "01");
		payParams.put(Constants.ATTACH_TYPE, "05");
		payParams.put(Constants.EXTENSION, "1");
		//加解签证书参数
		CfcaInfoBo cfcaInfoBo = new CfcaInfoBo();
		// 解签证书
		// 解签证书
		cfcaInfoBo.setCerFile(cerFile);
		// 加签证书
		cfcaInfoBo.setPfxFile(pfxFile);
		// 加签密码
		cfcaInfoBo.setPfxFilePwd(pfxFilePwd);
		//商户ID
		cfcaInfoBo.setNpayMerId(hfMerId);
		
		// 转换成json格式
		String paramsStr = JSON.toJSONString(payParams);
		log.info("文件上传请求参数："+paramsStr);
		// 加签
		String sign = SecurityService.sign(paramsStr,cfcaInfoBo);
		HttpRequest httpRequest = HttpRequest.post(fileUrl).charset("UTF-8");
		//如果文件名称中有中文，请先使用URLEncoder.encode(filename, "UTF-8")对文件名编码
		File newFile = new File("D:/app/a.jpg");
		// 发送请求给汇付
		HttpResponse httpResponse = httpRequest
				.contentType("multipart/form-data").form(
						"version",Constants.VERSION_VALUE,
						"mer_cust_id",merCustId,
						"check_value",sign,
						"attach_file", newFile)
				.send();
		// 取得同步返回数据
		String body = httpResponse.bodyText();
		// 进行验签
		String resultStr = SecurityService.parseCVResult(body,cfcaInfoBo);
		log.info("文件上传返回参数："+resultStr);
		return resultStr;
	}
}
